/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FormatRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FormatRequest{}

// FormatRequest struct for FormatRequest
type FormatRequest struct {
	Source *string `json:"source,omitempty"`
	//
	Rules []FormatRuleRequest `json:"rules,omitempty"`
}

// NewFormatRequest instantiates a new FormatRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFormatRequest() *FormatRequest {
	this := FormatRequest{}
	return &this
}

// NewFormatRequestWithDefaults instantiates a new FormatRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFormatRequestWithDefaults() *FormatRequest {
	this := FormatRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *FormatRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *FormatRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *FormatRequest) SetSource(v string) {
	o.Source = &v
}

// GetRules returns the Rules field value if set, zero value otherwise.
func (o *FormatRequest) GetRules() []FormatRuleRequest {
	if o == nil || IsNil(o.Rules) {
		var ret []FormatRuleRequest
		return ret
	}
	return o.Rules
}

// GetRulesOk returns a tuple with the Rules field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRequest) GetRulesOk() ([]FormatRuleRequest, bool) {
	if o == nil || IsNil(o.Rules) {
		return nil, false
	}
	return o.Rules, true
}

// HasRules returns a boolean if a field has been set.
func (o *FormatRequest) HasRules() bool {
	if o != nil && !IsNil(o.Rules) {
		return true
	}

	return false
}

// SetRules gets a reference to the given []FormatRuleRequest and assigns it to the Rules field.
func (o *FormatRequest) SetRules(v []FormatRuleRequest) {
	o.Rules = v
}

func (o FormatRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FormatRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Rules) {
		toSerialize["rules"] = o.Rules
	}
	return toSerialize, nil
}

type NullableFormatRequest struct {
	value *FormatRequest
	isSet bool
}

func (v NullableFormatRequest) Get() *FormatRequest {
	return v.value
}

func (v *NullableFormatRequest) Set(val *FormatRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFormatRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFormatRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFormatRequest(val *FormatRequest) *NullableFormatRequest {
	return &NullableFormatRequest{value: val, isSet: true}
}

func (v NullableFormatRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFormatRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
